﻿Select-From-Clipboard
======================
Плагин FAR для выделения из буфера обмена
-----------------------------------------
Версия 2.10 Unicode for FAR3  

**РАСПРОСТРАНЕНИЕ**: Freeware, по лицензии BSD (см. License.txt).

**КРАТКОЕ ОПИСАНИЕ**: Этот плагин к FAR переносит выделение из клипборда на панель,
то есть выделяет на панели файлы, имена которых находятся в клипборде.

**УСТАНОВКА**: Скопируйте ClipSel.dll в подкаталог каталога PLUGINS (напр.,
PLUGINS\ClipSel) и перезапустите FAR. После перезапуска нажмите F11. Появится
новый пункт меню - "Select from Clipboard". Для его вызова рекомендуется
назначить клавишный макрос Alt-Shift-Plus.

Этот плагин понимает два основных типа содержимого клипборда.

1. Текстовый клипборд

 Плагин производит простой разбор списка файлов в клипборде, полагая, что
все имена разделяются только символами перевода строки и другими 
управляющими символами, (с кодами менее 0x20). Такие разделители будем называть
"разделителями по умолчанию".

 Любые другие символы, такие как пробелы и запятые, тоже могут быть разделителями,
если их внести как дополнительные разделители в опциях плагина (см. ниже).

 В любом случае пробелы по краям имен файлов удаляются (даже если они заданы как
разделители), если только опция "Отсекать пробелы по краям" не отменена. Если вы
не определили пробел как дополнительный разделитель, он может быть в середине имени файла.

 Если имя взято в кавычки "", то всё, что между кавычками (кроме разделителей
по умолчанию), считается входящим в имя файла, безотносительно к настройкам
плагина.

 Дефолтовые настройки плагина хорошо работают со списками файлов, созданными:
 - клавишей Ctrl-Shift-Ins в панели FAR'а;
 - копированием имён файлов из командной строки FAR'а, если их туда
    вставить (Paste) после того же Ctrl-Shift-Ins;
 - командой "dir/b > myfile";
 - многими другими командами.


2. Файлы из Проводника Windows

 Если вы выделите файлы в Проводнике и нажмете Копировать (Ctrl-C), то плагин
поймет и такой список файлов.

 **ПРИМЕЧАНИЕ**: этот список будет содержать имена файлов с путями, но если текущая
панель - обычная файловая (не плагин), будут браться только имена без путей.
Если же вам надо "вставить" выделение имен из такого списка на плагиновую
панель с именами, вставьте этот список файлов в редактор FARа,
отредактируйте, убрав из него пути, и снова возьмите в клипборд.



Последующие замечания относится к обоим типам содержимого клипборда.

- Выделение происходит инкрементально, т.е. с файлов, выделенных ранее,
выделение НЕ снимается. Всегда можно нажать Shift-NumpadMinus перед командой
для снятия предыдущего выделения.

- По умолчанию регистр имен не различается, так что файлы README и readme
будут выбраны оба, если какой-нибудь из них будет найден в буфере обмена.
Будьте внимательны в таких случаях! Можно включить различение регистра в
диалоге Options, но это понадобится только тогда, когда вы работаете с
архивами UNIX, где различение регистра в именах - обычное дело.

- Если не включено различение регистра, то понимаются и длинные имена файлов,
и их досовские варианты, то есть в списке могут быть "Program Files",
или "PROGRA~1", или "progra~1". Если оно включено ([X] Case-sensitive),
то разыскиваются только длинные имена файлов, а имена DOS игнорируются.

- Если имя в клипборде не содержит бэкслэшей, а имя на панели - содержит, то
с первым сравнивается только часть панельного имени после последнего 
бэкслэша. Например, путь имени файла на временной панели не учитывается, 
если только имя в клипборде не содержит полного пути.

**Примечание**: если указать '\' в списке дополнительных разделителей в 
конфигурации, то имена в клипборде будут всегда отделяться от пути (если он 
есть), и тогда путь на временной панели не будет учитываться.


**НАСТРОЙКА**: FAR -> Options -> Plugins -> Select from Clipboard
открывает диалог конфигурации. В нем есть три настройки:

1. Дополнительные разделители.

 Все символы, которые здесь будут напечатаны, будут обрабатываться как
разделители имен файлов, несмотря на то, что они могут встречаться в именах
файлов. По умолчанию здесь пусто. Если имя взято в кавычки, то символы
из этого списка не действуют в нем как разделители.

2. Различать регистр

 Включите эту опцию, если требуется точное (с учетом регистра) сравнение
содержания клипборда с реальными именами файлов. По умолчанию она выключена.

3. Отсекать пробелы по краям

 Если включено (так по умолчанию), пробелы до и после имени файла перед
сравнением усекаются, если только они вместе с именем не взяты в кавычки.
Если выключено, они считаются частью имени файла (если только не перечислены
среди "дополнительных разделителей"), даже если кавычек нет.

-------------------------
Михаил Юцис  
Рамат-Ган, Израиль  
[yutsis@gmail.com](mailto:yutsis@gmail.com)  
http://michael-y.org/FAR  
http://plugring.farmanager.com/plugin.php?pid=18  
